
_set_up:

;Exp2.c,5 :: 		void set_up() {   //Configuration for Pic16F887
;Exp2.c,7 :: 		ANSEL = 0x0D;     // RA0, RA2 and RA3 set as analog inputs
	MOVLW      13
	MOVWF      ANSEL+0
;Exp2.c,8 :: 		ANSELH = 0;      // Rest of the pins set as digital inputs or outputs.
	CLRF       ANSELH+0
;Exp2.c,9 :: 		TRISA = 0x0D;
	MOVLW      13
	MOVWF      TRISA+0
;Exp2.c,10 :: 		ADCON0 = 0x41;  // ADC ON and Fosc/8 is selected
	MOVLW      65
	MOVWF      ADCON0+0
;Exp2.c,11 :: 		ADFM_bit = 1;   // Conversion result is right justified.
	BSF        ADFM_bit+0, BitPos(ADFM_bit+0)
;Exp2.c,12 :: 		ADCON1.F4 = 1;  // VREF+ = 5v.
	BSF        ADCON1+0, 4
;Exp2.c,13 :: 		ADCON1.F5 = 1;   // VREF- = GND.
	BSF        ADCON1+0, 5
;Exp2.c,14 :: 		C1ON_bit = 0;    // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;Exp2.c,15 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;Exp2.c,16 :: 		CCP1CON = 0;   //PWM1 y PWM2 off.
	CLRF       CCP1CON+0
;Exp2.c,17 :: 		CCP2CON = 0;
	CLRF       CCP2CON+0
;Exp2.c,18 :: 		TRISD = 0;
	CLRF       TRISD+0
;Exp2.c,19 :: 		PORTD = 0;
	CLRF       PORTD+0
;Exp2.c,20 :: 		}
L_end_set_up:
	RETURN
; end of _set_up

_ADC_Read:

;Exp2.c,21 :: 		unsigned int ADC_Read(unsigned char channel)
;Exp2.c,24 :: 		ADCON0 &= 0x11000101; //Clearing the Channel Selection Bits
	MOVLW      1
	ANDWF      ADCON0+0, 1
;Exp2.c,25 :: 		ADCON0 |= channel<<3; //Setting the required Bits
	MOVF       FARG_ADC_Read_channel+0, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	IORWF      ADCON0+0, 1
;Exp2.c,26 :: 		delay_ms(2); //Acquisition time to charge hold capacitor
	MOVLW      6
	MOVWF      R12+0
	MOVLW      48
	MOVWF      R13+0
L_ADC_Read0:
	DECFSZ     R13+0, 1
	GOTO       L_ADC_Read0
	DECFSZ     R12+0, 1
	GOTO       L_ADC_Read0
	NOP
;Exp2.c,27 :: 		GO_DONE_bit = 1; //Initializes A/D Conversion
	BSF        GO_DONE_bit+0, BitPos(GO_DONE_bit+0)
;Exp2.c,28 :: 		while(GO_DONE_bit); //Wait for A/D Conversion to complete
L_ADC_Read1:
	BTFSS      GO_DONE_bit+0, BitPos(GO_DONE_bit+0)
	GOTO       L_ADC_Read2
	GOTO       L_ADC_Read1
L_ADC_Read2:
;Exp2.c,29 :: 		return ((ADRESH<<8)+ADRESL); //Returns Result
	MOVF       ADRESH+0, 0
	MOVWF      R0+1
	CLRF       R0+0
	MOVF       ADRESL+0, 0
	ADDWF      R0+0, 1
	BTFSC      STATUS+0, 0
	INCF       R0+1, 1
;Exp2.c,30 :: 		}
L_end_ADC_Read:
	RETURN
; end of _ADC_Read

_main:

;Exp2.c,32 :: 		void main() {
;Exp2.c,33 :: 		set_up();
	CALL       _set_up+0
;Exp2.c,34 :: 		while (1)  {
L_main3:
;Exp2.c,35 :: 		rd_adc = ADC_Read(0)/4;// Reduce the resolution to 8 bits.
	CLRF       FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+0, 0
	MOVWF      _rd_adc+0
	MOVF       R0+1, 0
	MOVWF      _rd_adc+1
	RRF        _rd_adc+1, 1
	RRF        _rd_adc+0, 1
	BCF        _rd_adc+1, 7
	RRF        _rd_adc+1, 1
	RRF        _rd_adc+0, 1
	BCF        _rd_adc+1, 7
;Exp2.c,36 :: 		delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main5:
	DECFSZ     R13+0, 1
	GOTO       L_main5
	DECFSZ     R12+0, 1
	GOTO       L_main5
	NOP
	NOP
;Exp2.c,37 :: 		PORTD = rd_adc;
	MOVF       _rd_adc+0, 0
	MOVWF      PORTD+0
;Exp2.c,38 :: 		delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main6:
	DECFSZ     R13+0, 1
	GOTO       L_main6
	DECFSZ     R12+0, 1
	GOTO       L_main6
	NOP
	NOP
;Exp2.c,39 :: 		}
	GOTO       L_main3
;Exp2.c,41 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
