

unsigned int rd_adc=0;

void set_up() {   //Configuration for Pic16F887

  ANSEL = 0x0D;     // RA0, RA2 and RA3 set as analog inputs
  ANSELH = 0;      // Rest of the pins set as digital inputs or outputs.
  TRISA = 0x0D;
  ADCON0 = 0x41;  // ADC ON and Fosc/8 is selected
  ADFM_bit = 1;   // Conversion result is right justified.
  ADCON1.F4 = 1;  // VREF+ = 5v.
  ADCON1.F5 = 1;   // VREF- = GND.
  C1ON_bit = 0;    // analog comparators off.
  C2ON_bit = 0;
  CCP1CON = 0;   //PWM1 y PWM2 off.
  CCP2CON = 0;
  TRISD = 0;
  PORTD = 0;
}
unsigned int ADC_Read(unsigned char channel)
{

  ADCON0 &= 0x11000101; //Clearing the Channel Selection Bits
  ADCON0 |= channel<<3; //Setting the required Bits
  delay_ms(2); //Acquisition time to charge hold capacitor
  GO_DONE_bit = 1; //Initializes A/D Conversion
  while(GO_DONE_bit); //Wait for A/D Conversion to complete
  return ((ADRESH<<8)+ADRESL); //Returns Result
}

void main() {
  set_up();
   while (1)  {
      rd_adc = ADC_Read(0)/4;// Reduce the resolution to 8 bits.
      delay_ms(5);
      PORTD = rd_adc;
      delay_ms(5);
   }

}